var popup_url = chrome.extension.getURL('popup.html');

var updates = [];
var new_updates = [];
var unread_count = 0;

function getApplication() {
  return Application;
}

function startFresh() {
  
  Application.updates = {
		home:[],
		mentions:[],
		messages:[]
	}
	
	Application.counts = {
		home:0,
		mentions:0,
		messages:0
	}
	
	Application.fetchUpdates();
}

var Application = {
  last_search:'',
	timelines: ['home', 'mentions', 'messages'],
	
	updates: {
		home:[],
		mentions:[],
		messages:[]
	},
	
	counts: {
		home:0,
		mentions:0,
		messages:0
	},
	
	markAsRead:function(timeline) {
	  Application.counts[timeline] = 0;
	  this.updateBadge();
	},

	getUpdates:function(only_new) {
	  if (only_new) {
	    var ret = new_updates;
	    new_updates = []
	    return ret;
	  } else {
	    return updates;
	  }
	},

	fetchUpdates:function() {
	  console.log("Fetching updates...");
		$.each(Application.timelines, function() {
			var current_timeline = this;
		  if (Presently.fetching[current_timeline]) return true;
		  Presently.timelines[current_timeline]({
		    since_id:localStorage['last_fetched_' + current_timeline + '_id'],
		    callback:function(incoming_updates) {
		      var new_updates = incoming_updates;
					
		      if (new_updates.length > 0) {
		        localStorage['last_fetched_' + current_timeline + '_id'] = new_updates[0].id;
		
		        Application.updates[current_timeline] = new_updates.concat(Application.updates[current_timeline]);        
						Application.counts[current_timeline] = Application.getUnreadCount(current_timeline);
						Application.updateBadge();
		      }

		      Application.inPopup(function(ups) {
						this.$('div.spinner').fadeOut();
						if (this.currentTimeline() == current_timeline)
		        	this.renderUpdates(ups, true);
		      }, new_updates);
		    }
		  });
		});
	},
	
	getUnreadCount:function(timeline) {
		var timeline = timeline;
		var count = 0;
		$.each(Application.updates[timeline], function() {
			if (this.id > parseInt(localStorage['last_read_' + timeline + '_id']))
				count ++;
		});
		return count;
	},
	
	updateBadge:function() {
		if (Application.counts.messages > 0) {
			var count = Application.counts.messages;
			chrome.browserAction.setBadgeBackgroundColor({color:[230,120,10,255]});
		} else if (Application.counts.mentions > 0) {
			var count = Application.counts.mentions;
			chrome.browserAction.setBadgeBackgroundColor({color:[30,220,30,255]});
		}	else if (Application.counts.home > 0) {
			var count = Application.counts.home;
			chrome.browserAction.setBadgeBackgroundColor({color:[30,30,30,255]});
		}
		
		chrome.browserAction.setBadgeText({
      text:(count > 0 ? count.toString() : '')
    });
	},

	inPopup:function(func) {
	  var func = func;
	  var args = Array.prototype.slice.call(arguments, 1);
	  $.each(chrome.extension.getViews(), function() {
	    if (this.location.href == popup_url) {
	      func.apply(this, args);
	    }
	  });
	},

	startRefreshing:function() {
	  clearInterval(Application.fetchUpdates);
	  setInterval(Application.fetchUpdates, parseInt(localStorage['refresh_frequency'] || "300000"));
	}
}

$.each(Application.timelines, function() {
	localStorage['last_fetched_' + this + '_id'] = 1;
	localStorage['last_read_' + this + '_id'] = localStorage['last_read_' + this + '_id'] || 1;
});

Application.fetchUpdates();
Application.startRefreshing();