var Presenters = {
	autolink:function(string, options) {
		if(!options) options = {};
    if(!options.limit) options.limit = 10;
    if(!options.tagFill) options.tagFill = '';

    var regex = /((http\:\/\/|https\:\/\/|ftp\:\/\/)|(www\.))+(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/gi;

    string = string.replace(regex, function(value){
	    var m = value.match(/^([a-z]+:\/\/)/i);
	    var nice;
	    var url;

	    if(m) {
	      nice = value.replace(m[1],'');
	      url = value;
	    }
	
	    else {
	      nice = value;
	      url = 'http://' + nice;
	    }

	    return '<a target="_blank" href="' + url + '"' + (options.tagFill != '' ? (' ' + options.tagFill) : '')+ '>' + url + '</a>';
    });

    return string.replace(/@([a-z0-9_]{2,20})/gi,"<a target='_blank' rel='user' data-screen-name='$1'href='http://twitter.com/$1'>@$1</a>")
		 						 .replace(/#([a-z0-9_-]+)/gi,"<a target='_blank' rel='search' data-query='#$1' href='http://twitter.com/search?q=%23$1'>#$1</a>");
	},
	
	cache:{
		home:{},
		mentions:{},
		messages:{},
		search:{}
	},
	
	update:function(json, timeline) {
		if (Presenters.cache[timeline][json.id]) {
			return Presenters.cache[timeline][json.id];
		}
		
		// Handle Retweets
		if (json.retweeted_status) {
		  json.retweeted_status.retweeting_user = json.user;
		  json.retweeted_status.retweet_id = json.id;
		  Presenters.cache[timeline][json.id] = Presenters.update(json.retweeted_status, timeline);
		  return Presenters.cache[timeline][json.id]
		}
		
		var html = Presenters.autolink(json.text);
		var timeline = timeline;
		
		if (json.sender && json.sender.screen_name) json.user = json.sender;
		
		Presenters.cache[timeline][json.id] = {
			id: json.id,
			base_url: 'http://twitter.com',
			user_screen_name: json.user.screen_name,
			user_avatar: json.user.profile_image_url,
			user_name: json.user.name,
			text: html,
			timestamp: json.created_at,
			retweeting_user_screen_name: (json.retweeting_user ? json.retweeting_user.screen_name : null),
			is_retweet:function() {
			  return !!json.retweeting_user
			},
			is_new:function() {
			  console.log(json);
			  var timeline_id = json.retweet_id ? json.retweet_id : json.id;
				return timeline_id > parseInt(localStorage['last_read_' + timeline + '_id']);
			},
			own:function() {
				return json.user.screen_name == localStorage['username'];
			},
			mentioning:function() {
				return !!json.text.match(new RegExp("@" + localStorage['username'], "i"));
			},
			direct:function() { return (timeline == 'messages'); }
		}
		
		return Presenters.cache[timeline][json.id];
	},
	
	search_result:function(json) {
	  return {
	    text: json.text,
	    user: {
	      name: json.from_user,
	      screen_name: json.from_user,
	      profile_image_url: json.profile_image_url
	    },
	    created_at: json.created_at,
	    id: json.id
	  }
	}
}