

$.fn.selectRange = function(start, end) {
        return this.each(function() {
                if(this.setSelectionRange) {
                        this.focus();
                        this.setSelectionRange(start, end);
                } else if(this.createTextRange) {
                        var range = this.createTextRange();
                        range.collapse(true);
                        range.moveEnd('character', end);
                        range.moveStart('character', start);
                        range.select();
                }
        });
};

Presently = {
	consumer_key: '2sHADne0CvbA4tsuqLIYw',
	consumer_secret: 'gJ8LjZGNdai9IGxnOY3sdT8P8S7QF7psHtDxNHYwBM',
	
	fetching:{
		home:false,
		mentions:false,
		messages:false
	},
	
	rate_limited:false,
	
	consumer:function() {
		return new OAuth.Consumer(this.consumer_key, this.consumer_secret, {
			site:'https://api.twitter.com'
		});
	},
	
	access_token:function() {
		if (!localStorage['access_token'] || !localStorage['access_secret'])
			return null;
		
		return new OAuth.AccessToken(this.consumer(), localStorage['access_token'], localStorage['access_secret']);
	},
	
	request:function(method, path, opts) {
		if (Presently.rate_limited || !this.access_token()) return false;
		
		var options = {}
		var defaults = {
			dataType:'json',
			error:function(request) { alert(request.status) }
		}
		
		$.extend(options, defaults, opts);
		
		var callback = options.success;
		options.success = null;
		
		this.access_token().request(method, '/1' + path, options, callback);
	},
	
	update:function(text, cb) {
		Presently.request('POST','/statuses/update.json', {
			success:cb,
			data:{'status':text}
		});
	},
	
	retweet:function(id, cb) {
	  Presently.request('POST','/statuses/retweet/' + id + '.json', {
	    success:cb
	  });
	},
	
	search:function(query, since_id, cb) {
	  if (!cb) { cb = since_id; since_id = null; }
	  
	  $.ajax({
	    url:'http://search.twitter.com/search.json',
	    type:'GET',
	    data:{q:query,since_id:since_id},
	    dataType:'json',
	    success:cb,
	    error:Presently.timeline_error
	  });
	},
	
	verify_credentials:function(cb) {
		Presently.request('GET','/account/verify_credentials.json', {
			success:cb
		});
	},
	
	timelines:{
		home:function(options) {
			var callback = options.callback;
			Presently.request('GET','/statuses/home_timeline.json', {
				 data:{since_id:options.since_id,count:50},
				 success:options.callback, 
				 beforeSend:function(){ Presently.fetching.home = true;},
				 complete:function(){ Presently.fetching.home = false;},
				 error:Presently.timeline_error
			});
		}	,

		mentions:function(options) {
			var callback = options.callback;
			Presently.request('GET','/statuses/mentions.json', {
				 data:{since_id:options.since_id,count:50},
				 success:options.callback, 
				 beforeSend:function(){ Presently.fetching.mentions = true;},
				 complete:function(){ Presently.fetching.mentions = false;},
				 error:Presently.timeline_error
			});
		},
		
		messages:function(options) {
			var callback = options.callback;
			Presently.request('GET','/direct_messages.json', {
				 data:{since_id:options.since_id,count:50},
				 success:options.callback, 
				 beforeSend:function(){ Presently.fetching.messages = true;},
				 complete:function(){ Presently.fetching.messages = false;},
				 error:Presently.timeline_error
			});
		}
	},
	
	timeline_error:function(request) {
	  console.log("Error with request: ", request)
    if (request.status.toString() == '304') {
		  callback.call(request, []);
		} else if (request.status.toString() == '400') {
			console.log('400 received');
			var rateLimitExpire = request.getResponseHeader('X-RateLimit-Reset');
			if (rateLimitExpire) {
				var jsEpoch = parseInt(rateLimitExpire) * 1000
				var resumeDate = new Date();
				var now = new Date();
				resumeDate.setTime(jsEpoch);
				
				var timeout = jsEpoch - now.getTime();
				
				var minutes = timeout / 1000 / 60;
				if (!Presently.rate_limited) alert('Twitter rate limit exceeded. Refreshing will resume in ' + minutes);
				
				Presently.rate_limited = true;
				setTimeout(function(){Presently.rate_limited = false;}, timeout);
			}
		}
  }
}